library(rgdal)
library(geojsonio)
library(leaflet)


download.file(url = "https://development-data-hub-s3-public.s3.amazonaws.com/ddhfiles/145267/electric-network-lebanon.geojson",
              destfile = "./data/electric-network-lebanon.geojson")



inputjson <-"./data/electric-network-lebanon.geojson"

electric_network <- geojsonio::geojson_read(inputjson)

pal <- colorNumeric("viridis", NULL)

leaflet(electric_network) %>%
  addTiles() %>%
  leaflet::addGeoJSON(geojson = electric_network) %>% 
  fitBounds(35, 33, 37, 35)

cityCounter <- 1
lineCounter <- 1
# add an ID column
electric_network$features <- lapply(electric_network$features, function(x){
  if(is.null(x$properties$name)){
    x$properties$id <- paste0("line_", lineCounter)
    lineCounter <<- lineCounter + 1
    x$properties$name <- x$properties$id
  }else{
    x$properties$id <- paste0("city_", lineCounter)
    cityCounter <<- cityCounter + 1
  }
  x
})

# 
# 
# #extract features and coordinates
# features<- do.call(rbind, lapply(electric_network$features, function(x){
#     # replace NULL with NA
#     props <- as.data.frame(t(sapply(x$properties, function(y){y[is.null(y)] <- NA;y})))
#     coord <- t(sapply(x$geometry$coordinates, cbind))
#     coord <- apply(coord, MAR = 1, paste, collapse = ",")
#     out <- cbind(data.frame(type = x$type), props, coord = coord)
#     return(out)
#   }))
# 
# unique_features <- unique(features[,-which(colnames(features) == "coord")])
# 
# # connections
# connections <- do.call(rbind, lapply(split(features, features$coord), function(x){
#   # expand.grid(x$id, x$id)
#   if(length(x$id) > 1){
#     
#     out <- t(combn(x$id, 2))
#     #remove line to line connections at city intersections
#     toremove <- which(grepl("line", out[,1]) & grepl("line", out[,2]))
#     out[-toremove,]
#     
#   }else{
#     NULL
#   }
#   
# }))
# 
# 
# library(igraph)
# 
# ig <- igraph::graph_from_data_frame(connections)
# m <- match(igraph::vertex.attributes(ig)$name, unique_features$id)
# for (i in 1:ncol(unique_features)){
#   igraph::vertex.attributes(ig)[[colnames(unique_features)[i]]] <- unique_features[m,i]
# }
# 
# 
# plot(ig)
# library(visNetwork)
# 
# visNetwork::visIgraph(ig)


  